

#  Not blank function
def not_blank(question):

    error = "Sorry this can’t be blank.  Please type something."

    valid = False
    while not valid:

        response = input(question)
        if response != "":
            return response
        else:
            print(error)


# Number checking function (number must be a float that is more than 0)
def num_check(question):

    error = "Please enter a number that is more than zero"

    valid = False
    while not valid:
        response = input(question)

        if response == "":
            print(error)
            continue

        try:
            response = float(response)

            if response <= 0:
                print(error)
            else:
                return response

        except NameError:
            print(error)

        except ValueError:
            print(error)

        except SyntaxError:
            print(error)


# Main Routine

# initialise variables

fixed_costs = []

# Fixed costs
print("Fixed costs are charge that don’t change")
print()
print("Please enter the fixed costs for your project.  When  you have finished "
      "entering the costs, type 'xxx'.  If there are no fixed costs, please type 'xxx'.")
print()

get_costs = ""
while get_costs != "xxx":
    cost_line = []
    # get item name
    item_name = not_blank("Cost Name: ")
    if item_name.lower() == "xxx":
        break

    # get amount
    item_cost = num_check("Cost: $")

    # add item and cost to cost line
    cost_line.append(item_name)
    cost_line.append(item_cost)

    fixed_costs.append(cost_line)

fixed_costs.sort(key=lambda x: x[1], reverse=1)

if len(fixed_costs) > 0:
    # Output...
    print("**** Items by Cost <Most Expensive to Least Expensive> *******")
    for item in fixed_costs:
        print("{}: ${:.2f}".format(item[0], item[1]))

    fixed_total = 0
    for item in fixed_costs:
        fixed_total += item[1]

    print()
    print("Fixed Costs Sub Total: ${:.2f}".format(fixed_total))
else:
    print("There are no fixed costs for this project")
