

#  Not blank function
def not_blank(question):

    error = "Sorry this can’t be blank.  Please type something."

    valid = False
    while not valid:

        response = input(question)
        if response != "":
            return response
        else:
            print(error)


# Number checking function (number must be a float that is more than 0)
def num_check(question):

    error = "Please enter a number that is more than zero"

    valid = False
    while not valid:
        response = input(question)

        if response == "":
            print(error)
            continue

        try:
            response = float(response)

            if response <= 0:
                print(error)
            else:
                return response

        except NameError:
            print(error)

        except ValueError:
            print(error)

        except SyntaxError:
            print(error)


def get_items(question, amount=None):

    costs = []

    get_item = ""
    while get_item != "xxx":
        item_line = []
        # get item name
        item_name = not_blank(question)
        if item_name.lower() == "xxx":
            break

        # get amount
        item_cost = num_check("Cost: $")

        # If necessary, get number of items and find cost for all items
        if amount is not None:
            num_items = num_check("How many items? ")
            item_cost *= num_items

        # add item and cost to cost line
        item_line.append(item_name)
        item_line.append(item_cost)

        costs.append(item_line)

    costs.sort(key=lambda x: x[1], reverse=1)

    return costs


def show_output(cost_list, heading):

    if len(cost_list) > 0:
        print()
        count = 0
        total = 0
        print("**** {} <Most Expensive to Least Expensive> *******".format(heading))

        for item in cost_list:
            print("{}: ${:.2f}".format(cost_list[count][0], cost_list[count][1]))
            total += cost_list[count][1]
            count += 1

        print()
        print("{} Sub Total: ${:.2f}".format(heading, total))
    else:
        print("There are no {} for this project".format(heading.lower()))


# Main Routine

# Fixed costs
print("Fixed costs are charge that don’t change")
print()
print("Please enter the fixed costs for your project.  When  you have finished "
      "entering the costs, type 'xxx'.  If there are no fixed costs, please type 'xxx'.")
print()

# Get fixed costs...
print("*** Enter fixed Costs ***")
fixed_costs = get_items("Cost Name: ")
print(fixed_costs)
print()

# Get variable costs...
print("*** Enter Variable Costs ****")
variable_costs = get_items("Cost Name: ", "yes")
print(variable_costs)
print()

# Output fixed costs....
show_output(fixed_costs, "Fixed Costs")
show_output(variable_costs, "Variable Costs")


